/* Copyright (c) 2000-2008 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
Components.utils.import("resource://gre/modules/js_beautify.js");

function koJavaScriptFormatter() { }

koJavaScriptFormatter.prototype = {
    // XPCOM fields
    classDescription: "Komodo JavaScript Formatter",
    classID:          Components.ID("{a151657b-ec6f-4494-9e43-8bbae2bca701}"),
    contractID:       "@activestate.com/koFormatter?name=js_beautifer;1",
    QueryInterface: XPCOMUtils.generateQI([Components.interfaces.koIFormatter]),
    // [optional] an array of categories to register this component in.
    _xpcom_categories: [{ category: "category-komodo-formatter" }],

    // Internal
    _supported_languages: ["JavaScript"],

    // koIFormatter fields
    name: "js_beautifier",
    prettyName: "JS Beautifier",
    supportsLanguage: function(lang) {
        return this._supported_languages.indexOf(lang) >= 0;
    },
    getSupportedLanguages: function(count, retv) {
        count.value = this._supported_languages.length;
        return this._supported_languages;
    },
    format: function(context) {
        var indent_size = null;
        if (context.prefset.hasLongPref("indentWidth")) {
            indent_size = context.prefset.getLongPref("indentWidth");
        }
        context.text = js_beautify(context.text, indent_size);
    }
};

var components = [koJavaScriptFormatter];
function NSGetModule(compMgr, fileSpec) {
  return XPCOMUtils.generateModule(components);
}
